]> git.proxmox.com Git - mirror_lxc.git/blame - templates/lxc-download.in
templates: actually create DOWNLOAD_TEMP directory
[mirror_lxc.git] / templates / lxc-download.in
CommitLineData
71d3a659
SG
1#!/bin/sh
2
3# Client script for LXC container images.
4#
5# Copyright © 2014 Stéphane Graber <stgraber@ubuntu.com>
6#
7# This library is free software; you can redistribute it and/or
8# modify it under the terms of the GNU Lesser General Public
9# License as published by the Free Software Foundation; either
10# version 2.1 of the License, or (at your option) any later version.
11
12# This library is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
15# Lesser General Public License for more details.
16
17# You should have received a copy of the GNU Lesser General Public
18# License along with this library; if not, write to the Free Software
19# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
20# USA
21
22set -eu
23
71d3a659 24LOCALSTATEDIR="@LOCALSTATEDIR@"
f74e080c
SG
25LXC_HOOK_DIR="@LXCHOOKDIR@"
26LXC_TEMPLATE_CONFIG="@LXCTEMPLATECONFIG@"
71d3a659
SG
27
28# Defaults
71d3a659 29DOWNLOAD_ARCH=
f74e080c 30DOWNLOAD_BUILD=
b80f86f2 31DOWNLOAD_COMPAT_LEVEL=5
f74e080c 32DOWNLOAD_DIST=
71d3a659 33DOWNLOAD_FLUSH_CACHE="false"
41670b35 34DOWNLOAD_FORCE_CACHE="false"
f74e080c 35DOWNLOAD_INTERACTIVE="false"
dd2dbcb9 36DOWNLOAD_KEYID="0xE7FB0CAEC8173D669066514CBAEFF88C22F6E216"
f74e080c 37DOWNLOAD_LIST_IMAGES="false"
71d3a659 38DOWNLOAD_MODE="system"
b0f0932a 39DOWNLOAD_READY_GPG="false"
f74e080c
SG
40DOWNLOAD_RELEASE=
41DOWNLOAD_SERVER="images.linuxcontainers.org"
42DOWNLOAD_SHOW_GPG_WARNING="true"
43DOWNLOAD_SHOW_HTTP_WARNING="true"
44DOWNLOAD_TARGET="system"
45DOWNLOAD_URL=
46DOWNLOAD_USE_CACHE="false"
47DOWNLOAD_VALIDATE="true"
48DOWNLOAD_VARIANT="default"
edb5452c 49DOWNLOAD_TEMP=
71d3a659 50
f74e080c
SG
51LXC_MAPPED_GID=
52LXC_MAPPED_UID=
71d3a659
SG
53LXC_NAME=
54LXC_PATH=
55LXC_ROOTFS=
71d3a659 56
a9a53b50 57if [ -z "${DOWNLOAD_KEYSERVER:-}" ]; then
832cb182 58 DOWNLOAD_KEYSERVER="hkp://pool.sks-keyservers.net"
a6a7c7d1 59
832cb182
CB
60 # Deal with GPG over http proxy
61 if [ -n "${http_proxy:-}" ]; then
62 DOWNLOAD_KEYSERVER="hkp://p80.pool.sks-keyservers.net:80"
63 fi
4eb706b3
SG
64fi
65
207bf0e4
SG
66# Make sure the usual locations are in PATH
67export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin
68
71d3a659
SG
69# Some useful functions
70cleanup() {
832cb182
CB
71 if [ -d "${DOWNLOAD_TEMP}" ]; then
72 rm -Rf "${DOWNLOAD_TEMP}"
73 fi
71d3a659
SG
74}
75
acabe1fa 76wget_wrapper() {
832cb182
CB
77 for _ in $(seq 3); do
78 if wget "$@"; then
79 return 0
80 fi
81 done
acabe1fa 82
832cb182 83 return 1
acabe1fa
SG
84}
85
71d3a659 86download_file() {
832cb182
CB
87 if ! wget_wrapper -T 30 -q "https://${DOWNLOAD_SERVER}/$1" -O "$2" >/dev/null 2>&1; then
88 if ! wget_wrapper -T 30 -q "http://${DOWNLOAD_SERVER}/$1" -O "$2" >/dev/null 2>&1; then
89 if [ "$3" = "noexit" ]; then
90 return 1
91 else
92 echo "ERROR: Failed to download http://${DOWNLOAD_SERVER}/$1" 1>&2
93 exit 1
94 fi
95 elif [ "${DOWNLOAD_SHOW_HTTP_WARNING}" = "true" ]; then
96 DOWNLOAD_SHOW_HTTP_WARNING="false"
97 echo "WARNING: Failed to download the file over HTTPs" 1>&2
98 echo " The file was instead download over HTTP " 1>&2
99 echo "A server replay attack may be possible!" 1>&2
71d3a659 100 fi
832cb182 101 fi
71d3a659
SG
102}
103
fad96766 104download_sig() {
832cb182
CB
105 if ! download_file "$1" "$2" noexit; then
106 if [ "${DOWNLOAD_VALIDATE}" = "true" ]; then
107 if [ "$3" = "normal" ]; then
108 echo "ERROR: Failed to download http://${DOWNLOAD_SERVER}/$1" 1>&2
109 exit 1
110 else
111 return 1
112 fi
113 else
114 return 0
fad96766 115 fi
832cb182 116 fi
fad96766
DE
117}
118
71d3a659 119gpg_setup() {
832cb182
CB
120 if [ "${DOWNLOAD_VALIDATE}" = "false" ]; then
121 return
122 fi
123
124 if [ "${DOWNLOAD_READY_GPG}" = "true" ]; then
125 return
126 fi
127
128 echo "Setting up the GPG keyring"
129
130 mkdir -p "${DOWNLOAD_TEMP}/gpg"
131 chmod 700 "${DOWNLOAD_TEMP}/gpg"
132 export GNUPGHOME="${DOWNLOAD_TEMP}/gpg"
133
134 success=
135 for _ in $(seq 3); do
136 if gpg --keyserver "${DOWNLOAD_KEYSERVER}" \
137 --recv-keys "${DOWNLOAD_KEYID}" >/dev/null 2>&1; then
138 success=1
139 break
71d3a659 140 fi
832cb182
CB
141 break
142 done
71d3a659 143
832cb182
CB
144 if [ -z "${success}" ]; then
145 echo "ERROR: Unable to fetch GPG key from keyserver"
146 exit 1
147 fi
b0f0932a 148
832cb182 149 DOWNLOAD_READY_GPG="true"
71d3a659
SG
150}
151
152gpg_validate() {
832cb182
CB
153 if [ "${DOWNLOAD_VALIDATE}" = "false" ]; then
154 if [ "${DOWNLOAD_SHOW_GPG_WARNING}" = "true" ]; then
155 echo "WARNING: Running without gpg validation!" 1>&2
71d3a659 156 fi
832cb182
CB
157 DOWNLOAD_SHOW_GPG_WARNING="false"
158 return 0
159 fi
71d3a659 160
832cb182
CB
161 if ! gpg --verify "$1" >/dev/null 2>&1; then
162 echo "ERROR: Invalid signature for $1" 1>&2
163 exit 1
164 fi
71d3a659
SG
165}
166
167in_userns() {
832cb182
CB
168 [ -e /proc/self/uid_map ] || { echo no; return; }
169 while read -r line; do
170 fields="$(echo "$line" | awk '{ print $1 " " $2 " " $3 }')"
171 if [ "${fields}" = "0 0 4294967295" ]; then
172 echo no;
173 return;
174 fi
175 if echo "${fields}" | grep -q " 0 1$"; then
176 echo userns-root;
177 return;
178 fi
179 done < /proc/self/uid_map
180
181 [ "$(cat /proc/self/uid_map)" = "$(cat /proc/1/uid_map)" ] && { echo userns-root; return; }
182 echo yes
71d3a659
SG
183}
184
185relevant_file() {
832cb182
CB
186 FILE_PATH="${LXC_CACHE_PATH}/$1"
187
188 if [ -e "${FILE_PATH}-${DOWNLOAD_MODE}" ]; then
189 FILE_PATH="${FILE_PATH}-${DOWNLOAD_MODE}"
190 fi
71d3a659 191
832cb182
CB
192 if [ -e "${FILE_PATH}.${DOWNLOAD_COMPAT_LEVEL}" ]; then
193 FILE_PATH="${FILE_PATH}.${DOWNLOAD_COMPAT_LEVEL}"
194 fi
195
196 echo "${FILE_PATH}"
71d3a659
SG
197}
198
199usage() {
832cb182 200 cat <<EOF
71d3a659
SG
201LXC container image downloader
202
7d540a26 203Special arguments:
832cb182
CB
204[ -h | --help ]: Print this help message and exit
205[ -l | --list ]: List all available images and exit
7d540a26 206
71d3a659
SG
207Required arguments:
208[ -d | --dist <distribution> ]: The name of the distribution
209[ -r | --release <release> ]: Release name/version
210[ -a | --arch <architecture> ]: Architecture of the container
71d3a659
SG
211
212Optional arguments:
213[ --variant <variant> ]: Variant of the image (default: "default")
214[ --server <server> ]: Image server (default: "images.linuxcontainers.org")
215[ --keyid <keyid> ]: GPG keyid (default: 0x...)
d2e5c5d1 216[ --keyserver <keyserver> ]: GPG keyserver to use. Environment variable: DOWNLOAD_KEYSERVER
71d3a659
SG
217[ --no-validate ]: Disable GPG validation (not recommended)
218[ --flush-cache ]: Flush the local copy (if present)
e145b7bb 219[ --force-cache ]: Force the use of the local copy even if expired
71d3a659
SG
220
221LXC internal arguments (do not pass manually!):
222[ --name <name> ]: The container name
223[ --path <path> ]: The path to the container
224[ --rootfs <rootfs> ]: The path to the container's rootfs
2133f58c
SH
225[ --mapped-uid <map> ]: A uid map (user namespaces)
226[ --mapped-gid <map> ]: A gid map (user namespaces)
d2e5c5d1
TK
227
228Environment Variables:
229DOWNLOAD_KEYSERVER : The URL of the key server to use, instead of the default.
230 Can be further overridden by using optional argument --keyserver
231
71d3a659 232EOF
832cb182 233 return 0
71d3a659
SG
234}
235
3f7be9d0 236if ! options=$(getopt -o d:r:a:hl -l dist:,release:,arch:,help,list,variant:,\
3cd988cc 237server:,keyid:,keyserver:,no-validate,flush-cache,force-cache,name:,path:,\
3f7be9d0 238rootfs:,mapped-uid:,mapped-gid: -- "$@"); then
832cb182
CB
239 usage
240 exit 1
71d3a659
SG
241fi
242eval set -- "$options"
243
244while :; do
832cb182
CB
245 case "$1" in
246 -h|--help) usage && exit 1;;
247 -l|--list) DOWNLOAD_LIST_IMAGES="true"; shift 1;;
248 -d|--dist) DOWNLOAD_DIST="$2"; shift 2;;
249 -r|--release) DOWNLOAD_RELEASE="$2"; shift 2;;
250 -a|--arch) DOWNLOAD_ARCH="$2"; shift 2;;
251 --variant) DOWNLOAD_VARIANT="$2"; shift 2;;
252 --server) DOWNLOAD_SERVER="$2"; shift 2;;
253 --keyid) DOWNLOAD_KEYID="$2"; shift 2;;
254 --keyserver) DOWNLOAD_KEYSERVER="$2"; shift 2;;
255 --no-validate) DOWNLOAD_VALIDATE="false"; shift 1;;
256 --flush-cache) DOWNLOAD_FLUSH_CACHE="true"; shift 1;;
257 --force-cache) DOWNLOAD_FORCE_CACHE="true"; shift 1;;
258 --name) LXC_NAME="$2"; shift 2;;
259 --path) LXC_PATH="$2"; shift 2;;
260 --rootfs) LXC_ROOTFS="$2"; shift 2;;
261 --mapped-uid) LXC_MAPPED_UID="$2"; shift 2;;
262 --mapped-gid) LXC_MAPPED_GID="$2"; shift 2;;
263 *) break;;
264 esac
71d3a659
SG
265done
266
267# Check for required binaries
268for bin in tar xz wget; do
832cb182
CB
269 if ! command -V "${bin}" >/dev/null 2>&1; then
270 echo "ERROR: Missing required tool: ${bin}" 1>&2
271 exit 1
272 fi
71d3a659
SG
273done
274
275# Check for GPG
3f7be9d0 276if [ "${DOWNLOAD_VALIDATE}" = "true" ]; then
832cb182
CB
277 if ! command -V gpg >/dev/null 2>&1; then
278 echo "ERROR: Missing recommended tool: gpg" 1>&2
279 echo "You can workaround this by using --no-validate" 1>&2
280 exit 1
281 fi
71d3a659
SG
282fi
283
284# Check that we have all variables we need
3f7be9d0 285if [ -z "${LXC_NAME}" ] || [ -z "${LXC_PATH}" ] || [ -z "${LXC_ROOTFS}" ]; then
832cb182
CB
286 if [ "${DOWNLOAD_LIST_IMAGES}" != "true" ]; then
287 echo "ERROR: Please pass the name, path, and rootfs for the container" 1>&2
288 exit 1
289 fi
71d3a659
SG
290fi
291
3f7be9d0 292USERNS="$(in_userns)"
f74e080c 293
3f7be9d0 294if [ "${USERNS}" != "no" ]; then
832cb182
CB
295 if [ "${USERNS}" = "yes" ]; then
296 if [ -z "${LXC_MAPPED_UID}" ] || [ "${LXC_MAPPED_UID}" = "-1" ]; then
297 echo "ERROR: In a user namespace without a map" 1>&2
298 exit 1
71d3a659 299 fi
832cb182
CB
300 DOWNLOAD_MODE="user"
301 DOWNLOAD_TARGET="user"
302 else
303 DOWNLOAD_MODE="user"
304 DOWNLOAD_TARGET="system"
305 fi
71d3a659
SG
306fi
307
832cb182
CB
308if [ -z "${DOWNLOAD_DIST}" ] || [ -z "${DOWNLOAD_RELEASE}" ] || [ -z "${DOWNLOAD_ARCH}" ]; then
309 DOWNLOAD_INTERACTIVE="true"
71d3a659
SG
310fi
311
312# Trap all exit signals
313trap cleanup EXIT HUP INT TERM
843a5874 314
edb5452c
SC
315# /tmp may be mounted in tmpfs or noexec
316if mountpoint -q /tmp; then
832cb182 317 DOWNLOAD_TEMP="${LXC_PATH}"
edb5452c
SC
318fi
319
3f7be9d0 320if ! command -V mktemp >/dev/null 2>&1; then
832cb182 321 DOWNLOAD_TEMP="${DOWNLOAD_TEMP}/tmp/lxc-download.$$"
843a5874 322else
1aeaca89 323 DOWNLOAD_TEMP="$(mktemp -p ${DOWNLOAD_TEMP} -d)"
843a5874 324fi
71d3a659 325
10a5fab6 326# Simply list images
832cb182
CB
327if [ "${DOWNLOAD_LIST_IMAGES}" = "true" ] || [ "${DOWNLOAD_INTERACTIVE}" = "true" ]; then
328 # Initialize GPG
329 gpg_setup
330
331 # Grab the index
332 DOWNLOAD_INDEX_PATH="/meta/1.0/index-${DOWNLOAD_MODE}"
333
334 echo "Downloading the image index"
335 if ! download_file "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}" "${DOWNLOAD_TEMP}/index" noexit ||
336 ! download_sig "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}.asc" "${DOWNLOAD_TEMP}/index.asc" noexit; then
337 download_file "${DOWNLOAD_INDEX_PATH}" "${DOWNLOAD_TEMP}/index" normal
338 download_sig "${DOWNLOAD_INDEX_PATH}.asc" "${DOWNLOAD_TEMP}/index.asc" normal
339 fi
340
341 gpg_validate "${DOWNLOAD_TEMP}/index.asc"
342
343 # Parse it
344 echo ""
345 echo "---"
346 printf "DIST\tRELEASE\tARCH\tVARIANT\tBUILD\n"
347 echo "---"
348 while IFS=';' read -r f1 f2 f3 f4 f5 f6; do
349 [ -n "${DOWNLOAD_DIST}" ] && [ "$f1" != "${DOWNLOAD_DIST}" ] && continue
350 [ -n "${DOWNLOAD_RELEASE}" ] && [ "$f2" != "${DOWNLOAD_RELEASE}" ] && continue
351 [ -n "${DOWNLOAD_ARCH}" ] && [ "$f3" != "${DOWNLOAD_ARCH}" ] && continue
352 [ -n "${DOWNLOAD_VARIANT}" ] && [ "$f4" != "${DOWNLOAD_VARIANT}" ] && continue
353 [ -z "${f5}" ] || [ -z "${f6}" ] && continue
354
355 printf "%s\t%s\t%s\t%s\t%s\n" "${f1}" "${f2}" "${f3}" "${f4}" "${f5}"
356 unset f1 f2 f3 f4 f5 f6
357 done < "${DOWNLOAD_TEMP}/index"
358 echo "---"
359
360 if [ "${DOWNLOAD_LIST_IMAGES}" = "true" ]; then
361 exit 1
362 fi
b0f0932a 363
832cb182
CB
364 # Interactive mode
365 echo ""
b0f0932a 366
832cb182
CB
367 if [ -z "${DOWNLOAD_DIST}" ]; then
368 echo "Distribution: "
369 read -r DOWNLOAD_DIST
370 fi
b0f0932a 371
832cb182
CB
372 if [ -z "${DOWNLOAD_RELEASE}" ]; then
373 echo "Release: "
374 read -r DOWNLOAD_RELEASE
375 fi
b0f0932a 376
832cb182
CB
377 if [ -z "${DOWNLOAD_ARCH}" ]; then
378 echo "Architecture: "
379 read -r DOWNLOAD_ARCH
380 fi
b0f0932a 381
832cb182 382 echo ""
10a5fab6
SG
383fi
384
71d3a659 385# Setup the cache
3f7be9d0 386if [ "${DOWNLOAD_TARGET}" = "system" ]; then
832cb182 387 LXC_CACHE_BASE="${LOCALSTATEDIR}/cache/lxc/"
71d3a659 388else
832cb182 389 LXC_CACHE_BASE="${HOME}/.cache/lxc/"
71d3a659
SG
390fi
391
6dc6f80b 392# Allow the setting of the LXC_CACHE_PATH with the usage of environment variables.
3f7be9d0
WG
393LXC_CACHE_PATH="${LXC_CACHE_PATH:-"${LXC_CACHE_BASE}"}"
394LXC_CACHE_PATH="${LXC_CACHE_PATH}/download/${DOWNLOAD_DIST}"
395LXC_CACHE_PATH="${LXC_CACHE_PATH}/${DOWNLOAD_RELEASE}/${DOWNLOAD_ARCH}/"
396LXC_CACHE_PATH="${LXC_CACHE_PATH}/${DOWNLOAD_VARIANT}"
b56661fe 397
3f7be9d0 398if [ -d "${LXC_CACHE_PATH}" ]; then
832cb182
CB
399 if [ "${DOWNLOAD_FLUSH_CACHE}" = "true" ]; then
400 echo "Flushing the cache..."
401 rm -Rf "${LXC_CACHE_PATH}"
402 elif [ "${DOWNLOAD_FORCE_CACHE}" = "true" ]; then
403 DOWNLOAD_USE_CACHE="true"
404 else
405 DOWNLOAD_USE_CACHE="true"
406 if [ -e "$(relevant_file expiry)" ]; then
407 if [ "$(cat "$(relevant_file expiry)")" -lt "$(date +%s)" ]; then
408 echo "The cached copy has expired, re-downloading..."
409 DOWNLOAD_USE_CACHE="false"
410 fi
71d3a659 411 fi
832cb182 412 fi
71d3a659
SG
413fi
414
415# Download what's needed
3f7be9d0 416if [ "${DOWNLOAD_USE_CACHE}" = "false" ]; then
832cb182
CB
417 # Initialize GPG
418 gpg_setup
419
420 # Grab the index
421 DOWNLOAD_INDEX_PATH="/meta/1.0/index-${DOWNLOAD_MODE}"
422
423 echo "Downloading the image index"
424 if ! download_file "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}" "${DOWNLOAD_TEMP}/index" noexit ||
425 ! download_sig "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}.asc" "${DOWNLOAD_TEMP}/index.asc" noexit; then
426 download_file "${DOWNLOAD_INDEX_PATH}" "${DOWNLOAD_TEMP}/index" normal
427 download_sig "${DOWNLOAD_INDEX_PATH}.asc" "${DOWNLOAD_TEMP}/index.asc" normal
428 fi
429
430 gpg_validate "${DOWNLOAD_TEMP}/index.asc"
431
432 # Parse it
433 while IFS=';' read -r f1 f2 f3 f4 f5 f6; do
434 if [ "${f1}" != "${DOWNLOAD_DIST}" ] || \
435 [ "${f2}" != "${DOWNLOAD_RELEASE}" ] || \
436 [ "${f3}" != "${DOWNLOAD_ARCH}" ] || \
437 [ "${f4}" != "${DOWNLOAD_VARIANT}" ] || \
438 [ -z "${f6}" ]; then
439 continue
71d3a659
SG
440 fi
441
832cb182
CB
442 DOWNLOAD_BUILD="${f5}"
443 DOWNLOAD_URL="${f6}"
71d3a659 444
832cb182
CB
445 unset f1 f2 f3 f4 f5 f6
446 break
447 done < "${DOWNLOAD_TEMP}/index"
3f7be9d0 448
832cb182
CB
449 if [ -z "${DOWNLOAD_URL}" ]; then
450 echo "ERROR: Couldn't find a matching image" 1>&1
451 exit 1
452 fi
71d3a659 453
832cb182
CB
454 if [ -d "${LXC_CACHE_PATH}" ] && [ -f "${LXC_CACHE_PATH}/build_id" ] && \
455 [ "$(cat "${LXC_CACHE_PATH}/build_id")" = "${DOWNLOAD_BUILD}" ]; then
456 echo "The cache is already up to date"
457 echo "Using image from local cache"
458 else
459 # Download the actual files
460 echo "Downloading the rootfs"
461 download_file "${DOWNLOAD_URL}/rootfs.tar.xz" "${DOWNLOAD_TEMP}/rootfs.tar.xz" normal
462 download_sig "${DOWNLOAD_URL}/rootfs.tar.xz.asc" "${DOWNLOAD_TEMP}/rootfs.tar.xz.asc" normal
463 gpg_validate "${DOWNLOAD_TEMP}/rootfs.tar.xz.asc"
464
465 echo "Downloading the metadata"
466 download_file "${DOWNLOAD_URL}/meta.tar.xz" "${DOWNLOAD_TEMP}/meta.tar.xz" normal
467 download_sig "$DOWNLOAD_URL/meta.tar.xz.asc" "${DOWNLOAD_TEMP}/meta.tar.xz.asc" normal
468 gpg_validate "${DOWNLOAD_TEMP}/meta.tar.xz.asc"
469
470 if [ -d "${LXC_CACHE_PATH}" ]; then
471 rm -Rf "${LXC_CACHE_PATH}"
472 fi
473 mkdir -p "${LXC_CACHE_PATH}"
474 mv "${DOWNLOAD_TEMP}/rootfs.tar.xz" "${LXC_CACHE_PATH}"
475 if ! tar Jxf "${DOWNLOAD_TEMP}/meta.tar.xz" -C "${LXC_CACHE_PATH}"; then
476 echo "ERROR: Invalid rootfs tarball." 2>&1
477 exit 1
478 fi
3f7be9d0 479
832cb182 480 echo "${DOWNLOAD_BUILD}" > "${LXC_CACHE_PATH}/build_id"
71d3a659 481
832cb182
CB
482 if [ -n "${LXC_MAPPED_UID}" ] && [ "${LXC_MAPPED_UID}" != "-1" ]; then
483 # As the script is run in strict mode (set -eu), all commands
484 # exiting with non 0 would make the script stop.
485 # || true or || : (more portable) prevents that.
486 chown -R "${LXC_MAPPED_UID}" "${LXC_CACHE_BASE}" >/dev/null 2>&1 || :
71d3a659 487 fi
832cb182
CB
488 if [ -n "${LXC_MAPPED_GID}" ] && [ "${LXC_MAPPED_GID}" != "-1" ]; then
489 chgrp -R "${LXC_MAPPED_GID}" "${LXC_CACHE_BASE}" >/dev/null 2>&1 || :
71d3a659 490 fi
832cb182
CB
491 echo "The image cache is now ready"
492 fi
71d3a659 493else
832cb182 494 echo "Using image from local cache"
71d3a659
SG
495fi
496
497# Unpack the rootfs
498echo "Unpacking the rootfs"
fecf101c
SG
499
500EXCLUDES=""
501excludelist=$(relevant_file excludes)
502if [ -f "${excludelist}" ]; then
832cb182
CB
503 while read -r line; do
504 EXCLUDES="${EXCLUDES} --exclude=${line}"
505 done < "${excludelist}"
71d3a659
SG
506fi
507
3f7be9d0
WG
508# Do not surround ${EXCLUDES} by quotes. This does not work. The solution could
509# use array but this is not POSIX compliant. The only POSIX compliant solution
510# is to use a function wrapper, but the latter can't be used here as the args
511# are dynamic. We thus need to ignore the warning brought by shellcheck.
512# shellcheck disable=SC2086
832cb182 513tar --anchored ${EXCLUDES} --numeric-owner -xpJf "${LXC_CACHE_PATH}/rootfs.tar.xz" -C "${LXC_ROOTFS}"
fecf101c 514
3f7be9d0 515mkdir -p "${LXC_ROOTFS}/dev/pts/"
fecf101c 516
71d3a659 517# Setup the configuration
3f7be9d0
WG
518configfile="$(relevant_file config)"
519fstab="$(relevant_file fstab)"
520if [ ! -e "${configfile}" ]; then
832cb182
CB
521 echo "ERROR: meta tarball is missing the configuration file" 1>&2
522 exit 1
71d3a659
SG
523fi
524
525## Extract all the network config entries
832cb182 526sed -i -e "/lxc.net.0/{w ${LXC_PATH}/config-network" -e "d}" "${LXC_PATH}/config"
71d3a659
SG
527
528## Extract any other config entry
3f7be9d0 529sed -i -e "/lxc./{w ${LXC_PATH}/config-auto" -e "d}" "${LXC_PATH}/config"
71d3a659
SG
530
531## Append the defaults
832cb182
CB
532{
533 echo ""
534 echo "# Distribution configuration"
535 cat "$configfile"
536} >> "${LXC_PATH}/config"
71d3a659
SG
537
538## Add the container-specific config
832cb182
CB
539{
540 echo ""
541 echo "# Container specific configuration"
542 if [ -e "${LXC_PATH}/config-auto" ]; then
543 cat "${LXC_PATH}/config-auto"
3f7be9d0 544 rm "${LXC_PATH}/config-auto"
832cb182
CB
545 fi
546 if [ -e "${fstab}" ]; then
547 echo "lxc.mount.fstab = ${LXC_PATH}/fstab"
548 fi
549 echo "lxc.uts.name = ${LXC_NAME}"
550} >> "${LXC_PATH}/config"
71d3a659
SG
551
552## Re-add the previously removed network config
553if [ -e "${LXC_PATH}/config-network" ]; then
832cb182
CB
554 {
555 echo ""
556 echo "# Network configuration"
557 cat "${LXC_PATH}/config-network"
3f7be9d0 558 rm "${LXC_PATH}/config-network"
832cb182 559 } >> "${LXC_PATH}/config"
71d3a659
SG
560fi
561
562TEMPLATE_FILES="${LXC_PATH}/config"
563
564# Setup the fstab
3f7be9d0 565if [ -e "${fstab}" ]; then
832cb182
CB
566 cp "${fstab}" "${LXC_PATH}/fstab"
567 TEMPLATE_FILES="${TEMPLATE_FILES};${LXC_PATH}/fstab"
71d3a659
SG
568fi
569
570# Look for extra templates
571if [ -e "$(relevant_file templates)" ]; then
832cb182
CB
572 while read -r line; do
573 fullpath="${LXC_ROOTFS}/${line}"
574 [ ! -e "${fullpath}" ] && continue
575 TEMPLATE_FILES="${TEMPLATE_FILES};${fullpath}"
576 done < "$(relevant_file templates)"
71d3a659
SG
577fi
578
579# Replace variables in all templates
3f7be9d0
WG
580OLD_IFS=${IFS}
581IFS=";"
582for file in ${TEMPLATE_FILES}; do
583 [ ! -f "${file}" ] && continue
832cb182
CB
584 sed -i "s#LXC_NAME#${LXC_NAME}#g" "${file}"
585 sed -i "s#LXC_PATH#${LXC_PATH}#g" "${file}"
586 sed -i "s#LXC_ROOTFS#${LXC_ROOTFS}#g" "${file}"
587 sed -i "s#LXC_TEMPLATE_CONFIG#${LXC_TEMPLATE_CONFIG}#g" "${file}"
588 sed -i "s#LXC_HOOK_DIR#${LXC_HOOK_DIR}#g" "${file}"
71d3a659 589done
3f7be9d0 590IFS=${OLD_IFS}
71d3a659 591
491a01cf 592# prevent mingetty from calling vhangup(2) since it fails with userns on CentOS / Oracle
3f7be9d0 593if [ -f "${LXC_ROOTFS}/etc/init/tty.conf" ]; then
832cb182 594 sed -i 's|mingetty|mingetty --nohangup|' "${LXC_ROOTFS}/etc/init/tty.conf"
6e53ca56
SC
595fi
596
3f7be9d0 597if [ -n "${LXC_MAPPED_UID}" ] && [ "${LXC_MAPPED_UID}" != "-1" ]; then
832cb182 598 chown "${LXC_MAPPED_UID}" "${LXC_PATH}/config" "${LXC_PATH}/fstab" >/dev/null 2>&1 || :
71d3a659 599fi
832cb182 600
3f7be9d0 601if [ -n "${LXC_MAPPED_GID}" ] && [ "${LXC_MAPPED_GID}" != "-1" ]; then
832cb182 602 chgrp "${LXC_MAPPED_GID}" "${LXC_PATH}/config" "${LXC_PATH}/fstab" >/dev/null 2>&1 || :
2133f58c 603fi
71d3a659
SG
604
605if [ -e "$(relevant_file create-message)" ]; then
832cb182
CB
606 echo ""
607 echo "---"
608 cat "$(relevant_file create-message)"
71d3a659
SG
609fi
610
611exit 0